> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Deposit to Vault

> Deposit tokens into a Morpho Vault to earn passive yield from interest paid by
borrowers.

Each vault accepts one unique token that can be deposited.

A Morpho Vault has one loan asset and can allocate deposits to multiple Morpho
markets. Users can deposit into a vault to start earning passive yield from interest
paid by borrowers. Vaults feature automated risk management, actively curating risk
exposure for all deposited assets so users don't need to make these decisions
themselves. Users maintain full control over their assets, can monitor the vault's
state at any time, and withdraw their liquidity at their discretion.
                    <Info>
                    **Required Allowances**

                        In order to make this transaction, token allowances need to be set for the following contracts.

                     - `<vault-contract-address>`
                    </Info>
                



## OpenAPI

````yaml /v1/combined_spec.json post /v1/morpho/deposit
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/morpho/deposit:
    post:
      tags:
        - Morpho
      summary: Deposit to Vault
      description: >-
        Deposit tokens into a Morpho Vault to earn passive yield from interest
        paid by

        borrowers.


        Each vault accepts one unique token that can be deposited.


        A Morpho Vault has one loan asset and can allocate deposits to multiple
        Morpho

        markets. Users can deposit into a vault to start earning passive yield
        from interest

        paid by borrowers. Vaults feature automated risk management, actively
        curating risk

        exposure for all deposited assets so users don't need to make these
        decisions

        themselves. Users maintain full control over their assets, can monitor
        the vault's

        state at any time, and withdraw their liquidity at their discretion.
                            <Info>
                            **Required Allowances**

                                In order to make this transaction, token allowances need to be set for the following contracts.

                             - `<vault-contract-address>`
                            </Info>
                        
      operationId: v1_morpho_deposit
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MorphoDepositRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.morpho.morpho_deposit(vault_address="0xc1256Ae5FF1cf2719D4937adb3bbCCab2E00A2Ca", amount=0.5, chain=models.MorphoDepositRequestChain.BASE, sender="0xF85272345eDa6aA3c6469C97065a676737e73f87", estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.morpho.morphoDeposit({
                vaultAddress: "0xc1256Ae5FF1cf2719D4937adb3bbCCab2E00A2Ca",
                amount: 0.5,
                chain: "base",
                sender: "0xF85272345eDa6aA3c6469C97065a676737e73f87",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    MorphoDepositRequest:
      properties:
        action_type:
          type: string
          const: MORPHO_DEPOSIT
          title: Action Type
          default: MORPHO_DEPOSIT
        vault_address:
          type: string
          title: Vault Address
          description: The vault address you are depositing to.
          examples:
            - '0xbEef047a543E45807105E51A8BBEFCc5950fcfBa'
          default: '0xc1256Ae5FF1cf2719D4937adb3bbCCab2E00A2Ca'
        amount:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount
          description: The amount of tokens to deposit into the vault.
          examples:
            - 1.5
          default: 0.5
        receiver:
          anyOf:
            - type: string
            - type: 'null'
          title: Receiver
          description: >-
            The address which will receive the shares from the vault
            representing their proportional ownership of the vault's assets.
            Defaults to the sender.
        chain:
          type: string
          enum:
            - arbitrum
            - base
            - ethereum
          title: Chain
          default: base
          examples:
            - base
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0xF85272345eDa6aA3c6469C97065a676737e73f87'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - vault_address
        - amount
        - chain
        - sender
      title: MorphoDepositRequest
      default:
        chain: base
        sender: '0xF85272345eDa6aA3c6469C97065a676737e73f87'
        vault_address: '0xc1256Ae5FF1cf2719D4937adb3bbCCab2E00A2Ca'
        amount: 0.5
      required_allowances:
        - <vault-contract-address>
    TransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
      type: object
      required:
        - transaction
      title: TransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````